---
title: XRFrame
slug: Web/API/XRFrame
tags:
  - 3D
  - API
  - AR
  - Animation
  - Augmented Reality
  - Frame
  - Interface
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XR
  - XRFrame
---
<div>{{APIRef("WebXR Device API")}}{{SecureContext_Header}}{{draft}}</div>

<p class="summary"><span class="seoSummary">A <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a> <code><strong>XRFrame</strong></code> object is passed into the {{domxref("XRSession.requestAnimationFrame", "requestAnimationFrame()")}} callback function and provides access to the information needed in order to render a single frame of animation for an {{domxref("XRSession")}} describing a VR or AR sccene.</span> Events which communicate the tracking state of objects also provide an <code>XRFrame</code> reference as part of their structure.</p>

<p class="summary">In addition to providing a reference to the {{domxref("XRSession")}} for which this frame is to be rendered, the {{domxref("XRFrame.getViewerPose", "getViewerPose()")}} method is provided to obtain the {{domxref("XRViewerPose")}} describing the viewer's position and orientation in space, and {{domxref("XRFrame.getPose", "getPose()")}} can be used to create an {{domxref("XRPose")}} describing the relative position of one {{domxref("XRSpace")}} relative to another.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{DOMxRef("XRFrame.session", "session")}} {{ReadonlyInline}}</dt>
 <dd>The {{DOMxRef("XRSession")}} that for which this <code>XRFrame</code> describes the tracking details for all objects. The information about a specific object can be obtained by calling one of the methods on the object.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{DOMxRef("XRFrame.getPose", "getPose()")}}</dt>
 <dd>Returns an {{domxref("XRPose")}} object representing the spatial relationship between the two specified {{domxref("XRSpace")}} objects.</dd>
 <dt>{{DOMxRef("XRFrame.getViewerPose", "getViewerPose()")}}</dt>
 <dd>Returns an {{domxref("XRViewerPose")}} describing the viewer's position and orientation in a given {{domxref("XRReferenceSpace")}}.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#xrframe-interface","XRFrame")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRFrame")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Spatial_tracking">Spatial tracking in WebXR</a></li>
</ul>
